//+------------------------------------------------------------------+
//|                                                       zscore.mq4 |
//|                                                        modulatum |
//+------------------------------------------------------------------+
#property copyright "Mod"

#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1 DeepSkyBlue //5min
#property indicator_color2 Blue
#property indicator_color3 Red  //15min
#property indicator_color4 Pink // 60min / 1hs
#property indicator_color5 Coral // 30min
#property indicator_color6 Gold  // 240 min / 4hr
#property indicator_minimum -10.0
#property indicator_maximum 10.0






//---- input parameters
extern int        barsToCount = 2000;

//---- buffers
double zscore1[],zscore2[],zscore3[],zscore4[],zscore5[],zscore6[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(6);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,zscore1);
   SetIndexLabel(0,"zscore1");   
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(1,zscore2);
   SetIndexLabel(1,"zscore2");
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(2,zscore3);
   SetIndexLabel(2,"zscore3");
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(3,zscore4);
   SetIndexLabel(3,"zscore4");
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(4,zscore5);
   SetIndexLabel(4,"zscore5");
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(5,zscore6);
   SetIndexLabel(5,"zscore6");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit = barsToCount;
   
//----
   
   for(int i = 0 ;i <= limit-20 ;i++)
   {  
      
      zscore1[i] = (iClose(NULL,5,i)-iMA(NULL,5,60,0,0,0,i))/iStdDev(NULL,5,60,0,0,0,i);
      zscore2[i] = (iClose(NULL,15,i)-iMA(NULL,15,60,0,0,0,i))/iStdDev(NULL,15,60,0,0,0,i);
      zscore3[i] = (iClose(NULL,30,i)-iMA(NULL,30,60,0,0,0,i))/iStdDev(NULL,30,60,0,0,0,i);
      zscore4[i] = (iClose(NULL,60,i)-iMA(NULL,60,60,0,0,0,i))/iStdDev(NULL,60,60,0,0,0,i);
      zscore5[i] = (iClose(NULL,240,i)-iMA(NULL,240,60,0,0,0,i))/iStdDev(NULL,240,60,0,0,0,i);
      zscore6[i] = (iClose(NULL,1440,i)-iMA(NULL,1440,60,0,0,0,i))/iStdDev(NULL,1440,60,0,0,0,i);  
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+